{$M 65520,0,0} {$P+}

uses crt,dos;

{$i mask.inc}

const hdrbytes    = 'iCode ICALL config file';
      rev         = '1.oo';

type  entry       = record
                      name      : string [80];
                      baud      : string [6];
                      stag      : byte;
                      smonat    : byte;
                      shour     : byte;
                      smin      : byte;

                      etag      : byte;
                      emonat    : byte;
                      ehour     : byte;
                      emin      : byte;
                      deltahour : byte;
                      deltamin  : byte;


                      upload    : boolean;
                      download  : boolean;
                      badlogoff : boolean;
                      msgwrite  : boolean;
                      msgread   : boolean;
                    end;
  fontsubsttable = array[0..255] of char;

  configtype = record
    header         : string [32];
    ralogDir       : string [128];
    backgroundansi : string [128];
    usercount      : byte;
    firstline      : byte;
    fontsubsttab   : fontsubsttable;
    username       : boolean;
    usehandle      : boolean;
    xposuser       : byte;
    lengthuser     : byte;
    coloruser      : byte;
    location       : boolean;
    xposlocation   : byte;
    lengthlocation : byte;
    colorlocation  : byte;
    baudrate       : boolean;
    xposbaudrate   : byte;
    formatbaudrate : byte;
    colorbaudrate  : byte;
    stime          : boolean;
    xposstime      : byte;
    formatstime    : byte;
    colorstime     : byte;
    etime          : boolean;
    xposetime      : byte;
    formatetime    : byte;
    coloretime     : byte;
    online         : boolean;
    xposonline     : byte;
    formatonline   : byte;
    coloronline    : byte;
    date           : boolean;
    xposdate       : byte;
    formatdate     : byte;
    colordate      : byte;
    badl           : boolean;
    xposbadl       : byte;
    asc2badl       : char;
    colorbadl      : byte;
    write          : boolean;
    xposwrite      : byte;
    asc2write      : char;
    colorwrite     : byte;
    read           : boolean;
    xposread       : byte;
    asc2read       : char;
    colorread      : byte;
    upload         : boolean;
    xposupload     : byte;
    asc2upload     : char;
    colorupload    : byte;
    download       : boolean;
    xposdownload   : byte;
    asc2download   : char;
    colordownload  : byte;
    end;
  str20 = string[20];


const logfilename : string = 'C:\RA\RA.LOG';
      buffersize  = 16384;
      users       = 14;
      usersfound  : byte = users;
      baudrate    : array[0..1] of str20 = ('28.8','28.800');
      timerec     : array[0..3] of str20 = ('HH:MM','HH:MM:SS','HH:MM A/P','HHMM');
      daterec     : array[0..7] of str20 = ('JJJJ-MM-TT','JJ-MM-TT','MM-TT',
      'TT.MM.JJJJ','TT.MM.JJ','TT.MM.','Montag, der TT.MM.JJ','Mon, TT.MM.');
      online      : array[0..2] of str20 = ('MMM','HH:MM','HH:MM:SS');
      save        : array[0..2] of str20 = ('Weitermachen','nderungen speichern','Arbeit verwerfen');


var   logfile     : file;
      buffer      : array [0..buffersize-1] of byte;
      filepos     : longint;
      bufpos      : word;
      actStr      : string;
      userdata    : array[1..users] of entry;
      usercount   : byte;
      actentry    : entry;

procedure error( e : byte );
begin
  writeln;
  writeln('iCode ICALL...');
  writeln;
  writeln('ERROR!!!');
  if e = 1 then writeln('Could not rewrite configfile !');
  if e = 2 then writeln('Invalid configfile !');
  if e = 3 then writeln('Could not open logfile !');
  writeln;
  halt;
end;

function upstr(s:string):string;
var
  a : byte;
begin
  for a:=1 to length(s) do s[a]:=upcase(s[a]);
  upstr:=s;
end;

function downstr(s:string):string;
var
  a : byte;
begin
  for a:=1 to length(s) do if s[a] in ['A'..'Z'] then s[a]:=chr(ord(s[a])+32);
  downstr:=s;
end;

procedure writestr(x,y,color:byte;s:string);
var
  a : byte;
begin
  if length(s)=0 then exit;
  for a:=1 to length(s) do
    memw[$b800:(y-1)*160+(x+a-2)*2]:=(color shl 8)+ord(s[a]);
end;

procedure writechar(x,y,color:byte;count:word;ch:char);
var
  a : word;
begin
  if count=0 then exit;
  for a:=1 to count do memw[$b800:(y-1)*160+(x+a-2)*2]:=(color shl 8)+ord(ch);
end;

procedure clearscreen;
begin
  writechar(1,3,$19,1680,'');
end;

procedure window(x1,y1,x2,y2:byte;title:string);
var
  a : byte;
begin
  writestr(x1,y1,$ed,'');
  writestr(x1+2,y1,$9d,'');
  writestr(x1+3,y1,$9f,title);
  writestr(x1+3+length(title),y1,$9d,'');
  writechar(x1+4+length(title),y1,$ed,x2-x1-4-length(title),'');
  writestr(x2,y1,$ed,'');
  for a:=y1+1 to y2-1 do
    begin
    writestr(x1,a,$ed,'');
    writechar(x1+1,a,$ed,x2-x1-1,' ');
    writestr(x2,a,$ed,'');
    writestr(x2+1,a,$19,'');
    end;
  writestr(x1,y2,$ed,'');
  writechar(x1+1,y2,$ed,x2-x1-1,'');
  writestr(x2,y2,$ed,'');
  writestr(x2+1,y2,$19,'');
  writechar(x1+1,y2+1,$19,x2-x1+1,'');
end;

procedure window2(x1,y1,x2,y2:byte;title:string);
var
  a : byte;
begin
  writestr(x1,y1,$dc,'');
  writestr(x1+1,y1,$dc,'');
  writestr(x1+3,y1,$9c,'');
  writestr(x1+4,y1,$9f,title);
  writestr(x1+4+length(title),y1,$9c,'');
  writechar(x1+5+length(title),y1,$dc,x2-x1-5-length(title),'');
  writestr(x2,y1,$d5,'');
  for a:=y1+1 to y2-1 do
    begin
    writestr(x1,a,$dc,'');
    writechar(x1+1,a,$dc,x2-x1-1,' ');
    writestr(x2,a,$d5,'');
    end;
  writestr(x1,y2,$4c,'');
  writechar(x1+1,y2,$d5,x2-x1-1,'');
  writestr(x2,y2,$d5,'');
end;

procedure window3(x1,y1,x2,y2:byte;title:string);
var
  a : byte;
begin
  writestr(x1,y1,$ed,'');
  writestr(x1+2,y1,$9d,'');
  writestr(x1+3,y1,$9f,title);
  writestr(x1+3+length(title),y1,$9d,'');
  writechar(x1+4+length(title),y1,$ed,x2-x1-4-length(title),'');
  writestr(x2,y1,$ed,'');
  for a:=y1+1 to y2-1 do
    begin
    writestr(x1,a,$ed,'');
    writechar(x1+1,a,$ed,x2-x1-1,' ');
    writestr(x2,a,$ed,'');
    end;
  writestr(x1,y2,$ed,'');
  writechar(x1+1,y2,$ed,x2-x1-1,'');
  writestr(x2,y2,$ed,'');
end;

procedure help(index:word);
var
  scrdump : array[0..3679] of byte;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  clearscreen;
  case index of
    0 : begin
      window(5,4,75,22,'Info ber iCall  Seite 1/2');
      writestr(7,6,$e7,'iCall Lastcaller-Scan Revision '+rev+' SHAREWARE');
      writestr(7,7,$e7,'Der beste und schnellste Lastcaller-Scanner aller Zeiten!');
      writestr(7,8,$e7,'Entwickelt von FAlCON und EsdimaX / iCode');

      writestr(7,10,$e7,'Dieses Produkt ist Shareware. Sie drfen dieses Programm nutzen');
      writestr(7,11,$e7,'und verbreiten, sofern Sie keine nderungen am Programmcode');
      writestr(7,12,$e7,'vornehmen. Fr das Kopieren der Sharewareversion drfen keine');
      writestr(7,13,$e7,'Gebhren erhoben werden.');

      writestr(7,15,$e7,'Sollte dieses Programm Ihnen zusagen, so da Sie eine lngerfris-');
      writestr(7,16,$e7,'tige Nutzung beabschichtigen, so mssen Sie dieses Programm regis-');
      writestr(7,17,$e7,'trieren lassen. Fr einen lcherlichen Betrag von nur 20 DM schik-');
      writestr(7,18,$e7,'ken wir Ihnen die Vollversion, mit noch mehr Konfigurationsmglich-');
      writestr(7,19,$e7,'keiten und ohne die strende Shareware-Meldung. Auerdem knnen Sie');
      writestr(7,20,$e7,'dann Ihre Sonderwnsche uern, die wir (falls das uns zeitlich');
      writestr(7,21,$e7,'mglich ist) mit in Ihre Vollversion mit integrieren.');
      while keypressed do readkey;
      readkey;
      window(5,4,75,22,'Info ber iCall  Seite 2/2');
      writestr(7,6,$e7,'iCall Lastcaller-Scan Revision '+rev+' SHAREWARE');

      writestr(7,8,$e7,'Weiterhin haben Sie dann das Recht auf kostenfreie Updates von');
      writestr(7,9,$e7,'iCall.');

      writestr(7,11,$e7,'Wie Sie sich registrieren lassen knnen, entnehmen Sie bitte');
      writestr(7,12,$e7,'der Datei REGISTER.DOC aus dem ICALL-Archiv.');

      writestr(7,15,$e7,'Halten Sie auch Ausschau nach weiteren ntzlichen iCode-Produkten!');
      writestr(7,16,$e7,'Die beste Verbindung ist der direkte Call unseres WHQ in Bdingen');
      writestr(7,17,$e7,'im Staate Deutschland:');
      writestr(7,18,$e7,'MilchBOX BBS Bdingen -> oo49-6o42-56o. 28.800 Baud, full ANSI!');
      writestr(27,20,$e7,'- - - See you later  - -');
      end;
    1 : begin { Fontsubstitution Table }
      window(5,4,75,22,'Hilfe: Font-Substitution Table');

      writestr(7,7,$e7,'Sie knnen in diesem Fenster eine bersetzungstabelle erstellen.');

      writestr(7,9,$e7,'Bevor im iCall LastCaller-Ansi ein Wort geschrieben wird, werden');
      writestr(7,10,$e7,'alle Zeichen gegen die Zeichen der Font-Substitution Tabelle');
      writestr(7,11,$e7,'ersetzt. Beispielsweise knnen Sie dadurch alle "E" gegen ein ""');
      writestr(7,12,$e7,'austauschen lassen.');

      writestr(7,14,$e7,'Im rechten Fenster (Blau) knnen Sie die Umdefinition der Zeichen');
      writestr(7,15,$e7,'vornehmen. Whlen Sie einfach mit den Cursortasten das jeweilige');
      writestr(7,16,$e7,'Zeichen, drcken Sie Enter und whlen Sie anschlieend das neue');
      writestr(7,17,$e7,'Zeichen aus der linken Spalte (Rot).');
      end;
    2 : begin { Ansi-Lister }
      window(5,4,75,21,'Hilfe: Ansi-Lister');

      writestr(7,6,$e7,'Auf dieser Page knnen Sie ein Hintergrund-Ansi whlen.');

      writestr(7,8,$e7,'Das Ansi-Bild wird als Grundlage fr das LastCaller-Bild verwendet');
      writestr(7,9,$e7,'und wird bei jedem Durchlauf von iCall mit den entsprechenden');
      writestr(7,10,$e7,'User-Informationen ergnzt. Das fertige Lastcaller-Bild wird dann');
      writestr(7,11,$e7,'im gleichen Verzeichnis wie das Hintergrundbild unter dem Namen');
      writestr(7,12,$e7,'ICALL.ANS abgelegt.');

      writestr(7,14,$e7,'Da iCall das Ansi-Bild verndert, haben wir ein Ansi-Interpeter');
      writestr(7,15,$e7,'implementieren mssen. Aus diesem Grund darf das Ansi-Bild keine');
      writestr(7,16,$e7,'Animationen und sonstige "unkonventionelle" Ansi-Befehle enthalten.');
      writestr(7,17,$e7,'Testen Sie daher vor dem Verwenden von iCall, ob Ihr Ansi-Bild auch');
      writestr(7,18,$e7,'mit iCall verwendbar ist.');
      end;
    4 : begin { Usercount }
      window(5,4,75,21,'Hilfe: User-Anzahl');

      writestr(7,6,$e7,'iCall sucht in der Datei RA.LOG nach den letzten Anrufern der Box.');
      writestr(7,7,$e7,'Sie knnen hier angeben, wieviele Anrufe rckwrts iCall suchen und');
      writestr(7,8,$e7,'anzeigen soll. Minimal knnen Sie nur den letzten User suchen');
      writestr(7,9,$e7,'lassen, jedoch kann iCall auch bis zu 25 User suchen.');

      writestr(7,11,$e7,'Sie sollten bedenken, da jeder Usereintrag eine Zeile auf dem');
      writestr(7,12,$e7,'Bildschirm in Anspruch nimmt. Daher sollten Sie Ihr ANSI-Bild fr');
      writestr(7,13,$e7,'den Hintergrund entsprechend anpassen. Da iCall einen extrem');
      writestr(7,14,$e7,'optimierten Suchalgorithmus verwendet, macht sich die Angabe einer');
      writestr(7,15,$e7,'greren Userzahl zeitlich kaum bemerkbar.');
      end;
    5 : begin { first Line }
      window(5,4,75,21,'Hilfe: erste Zeile');

      writestr(7,6,$e7,'Auf dieser Seite knnen Sie angeben, ab welcher Zeile die');
      writestr(7,7,$e7,'Auflistung der letzten Anrufe erfolgen soll.');

      writestr(7,9,$e7,'Sie sollten jedoch aufpassen, da Sie noch gengened freie Zeilen');
      writestr(7,10,$e7,'auf dem Bildschirm zu Verfgung haben. So wird eine Angabe von 25');
      writestr(7,11,$e7,'Usern und einer Anfangszeile 7 unweigerlich zu Fehlern fhren.');
      writestr(7,12,$e7,'berprfen Sie daher fters mit der Leertaste im Hauptmen das');
      writestr(7,13,$e7,'Design und korrigieren Sie eventuelle Fehler.');
      end;
    6,9,12,15,18,21,24,27,30,33,36,39 : begin { X-Pos }
      window(5,4,75,21,'Hilfe: X-Position');

      writestr(7,6,$e7,'Der X-Positons-Wert gibt die Spalte des jeweiligen Eintrages');
      writestr(7,7,$e7,'auf deM Bildschirm an.');

      writestr(7,9,$e7,'Die X-Werte sind fr jede Zeile gleich,so da die Angaben fr die');
      writestr(7,10,$e7,'einzelnen User stets untereinsander stehen. Sie knnen beispiels-');
      writestr(7,11,$e7,'weise festlegen, in welcher Spalte der Name oder die Baudrate');
      writestr(7,12,$e7,'beginnt. berprfen Sie aber stets, ob es nicht zu BERLAPPUNGEN');
      writestr(7,13,$e7,'unter den verschiedenen Anagben kommt!');
      end;
    7,10 : begin { Lngenangabe }
      window(5,4,75,21,'Hilfe: Lngenangabe');

      writestr(7,6,$e7,'Sowohl fr den Usernamen alsauch fr den Wohnort mu eine');
      writestr(7,7,$e7,'Lngenangabe genannt werden.');

      writestr(7,9,$e7,'Dieser Wert stellt maximale Lnge der beiden Strings dar. Sollte');
      writestr(7,10,$e7,'beispielsweise der Name zu lang sein, so wird er dadurch einfach');
      writestr(7,11,$e7,'abgeschnitten. Diese Option dient dem Zweck, da nihct ein zu');
      writestr(7,12,$e7,'langer Username andere Daten berschreiben kann. Andererseits');
      writestr(7,13,$e7,'bedeutet dies auch, da bei einer zu geringen Maximallnge des');
      writestr(7,14,$e7,'Strings, dieser oftmals nicht mehr vernnftig zu lesen ist.');
      end;
    8,11,14,17,20,23,26,29,32,35,38,41 : begin { Color-Dialog }
      window(5,4,75,21,'Hilfe: Color-Dialog');

      writestr(7,6,$e7,'Der Color-Dialog dient dazu, dem Eintrag eine entsprechenden');
      writestr(7,7,$e7,'Farbwert zuzuordnen.');

      writestr(7,9,$e7,'Ihre Auswahl wird dabei stets mit zwei kleinen Pfeilchen an beiden');
      writestr(7,10,$e7,'Seiten markiert. Whlen Sie einfach eine neue Farbkombination mit');
      writestr(7,11,$e7,'den Pfeiltasten und aktivieren oder deaktivieren Sie bei Bedarf');
      writestr(7,12,$e7,'das Blinkattribut der Schrift. Da iCall-Config einen spezeillen');
      writestr(7,13,$e7,'Videomodus verwendet, kann ein Blinken nicht dargestellt werden.');
      writestr(7,14,$e7,'Trotzdem informiert Sie ein kleines Kreuz, ob das Blink-Attribut');
      writestr(7,15,$e7,'aktiviert ist. Selbstverstendlich gilt diese Einschrnkung nicht');
      writestr(7,16,$e7,'fr das mit iCall generierte Ansi-Bild und auch nicht fr den');
      writestr(7,17,$e7,'Probemodus, der mit der Leertaste im Hauptmen aktiviert wird.');
      end;
    13 : begin { Format Baudrate }
      window(5,4,75,21,'Hilfe: Anzeigeformat Baudrate');

      writestr(7,6,$e7,'Fr die Bildschirmanzeige der Baudrate-Information gibt es derzeit');
      writestr(7,7,$e7,'zwei mgliche Einstellungen, die sich lediglich in ihrer Lnge');
      writestr(7,8,$e7,'unterscheiden.');

      writestr(7,10,$e7,'Im generierten Ansi-Bildist die Baud-Information stets nach rechts');
      writestr(7,11,$e7,'orientiert. Falls Sie wnschen, den Text "BPS" hinter der Angabe zu');
      writestr(7,12,$e7,'haben, so sollten Sie diesen in Ihr Hintergrund-Bild mit aufnehmen.');
      end;
    16,19 : begin { Format S/E-Time }
      window(5,4,75,21,'Hilfe: Zeitformat');

      writestr(7,6,$e7,'Fr die Start- und Endzeit der Verbindung gibt es mehrere');
      writestr(7,7,$e7,'Darstellungsmglichkeiten.');

      writestr(7,9,$e7,'Testen Sie einfach, welches Format Sie anspricht, indem Sie im');
              writestr(7,10,$e7,'Hauptmen eine Probeanzeige mittels der Lerrtaste aktivieren.');
      end;
    22 : begin { Format Online }
      window(5,4,75,21,'Hilfe: Anzeigeformat Onlinezeit');

      writestr(7,6,$e7,'Es gibt verschiedene Vorgabewerte, wie die Onlinezeit auf den');
      writestr(7,7,$e7,'Bildschirm ausgegeben werden kann.');

      writestr(7,9,$e7,'Da iCall stets nur die Zahl in das Hintergrund-Ansi eintrgt,');
      writestr(7,10,$e7,'mssen Sie fr den zustzlichen Text wie "min"  sorgen. Denken');
      writestr(7,11,$e7,'auch daran, die Zahlendarstellung durch die Substitution-Tab');
      writestr(7,12,$e7,'grafisch ein wenig aufzuwerten.');
      end;
    25 : begin { Format Datum }
      window(5,4,75,21,'Hilfe: Datumsformat');

      writestr(7,6,$e7,'Das Datum des Anrufes kann bei jedem User angezeigt werden.');
      writestr(7,7,$e7,'Hier whlen Sie aus, wie das Datum aussehen soll.');

      writestr(7,9,$e7,'Ein vernnftiger Sinn, weshalb das Datum bei jedem User stehen');
      writestr(7,10,$e7,'sollte ist uns noch nicht eingefallen, da das Datum eh fast');
      writestr(7,11,$e7,'immer gleich bleibt. Trotzdem haben wir diesen Luxus mitb');
      writestr(7,12,$e7,'implementiert - vielleciht knnen Sie damit ja was anfangen.');
      end;
    28,31,34,37,40 : begin { ASCII-Char }
      window(5,4,75,21,'Hilfe: ASCII-Char auswhlen');

      writestr(7,6,$e7,'In diesem Men knnen Sie einen Buchstaben auswhlen, der immer');
      writestr(7,7,$e7,'dann an die angegebene Position, wenn eine bestimmte Bedingung');
      writestr(7,8,$e7,'erfllt ist.');

      writestr(7,10,$e7,'Wenn der User beispielsweise eine Message schreibt, und Sie bei');
      writestr(7,11,$e7,'WRITE MESSAGE den Buchstaben "W" angegeben haben, so wird durch');
      writestr(7,12,$e7,'diesen Buchstaben im LastCaller-Ansi diese Aktion vermerkt.');
      writestr(7,13,$e7,'Falls der User keine Message schreibt und Sie dies durch ein Minus');
      writestr(7,14,$e7,'an der entsprechenden Bilchschirmposition darstellen wollen, so');
      writestr(7,15,$e7,'mu Ihr Hintergrund-Bild dieses Zeichen als Vorgabewert besitzen.');
      end;

    else
      begin
      move(scrdump,ptr($b800,160)^,sizeof(scrdump));
      exit;
      end;
    end;
  readkey;
  while keypressed do readkey;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure fontsubstitution(var fst : fontsubsttable);
var
  a,b     : byte;
  c,d     : byte;
  ch      : char;
  scrdump : array[0..3679] of byte;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  window3(5,4,75,22,'Font-Substitution Table');
  for a:=0 to 15 do
    for b:=0 to 15 do writestr(8+b*2,6+a,$e9,fst[a*16+b]);
  for a:=0 to 15 do
    for b:=0 to 15 do writestr(42+b*2,6+a,$ec,chr(a*16+b));
  a:=0;
  b:=0;
  writestr(7+b*2,6+a,$b9,' '+fst[a*16+b]+' ');
  repeat
    ch:=readkey;
    if ch=#0 then
      begin
      writestr(7+b*2,6+a,$e9,' '+fst[a*16+b]+' ');
      ch:=readkey;
      case ch of
        #59 : help(1);
        #72 : a:=(a-1) and $f;
        #75 : b:=(b-1) and $f;
        #77 : b:=(b+1) and $f;
        #80 : a:=(a+1) and $f;
        #71 : fst[a*16+b]:=chr(a*16+b);
        end;
      end;
    case ch of
      '+' : inc(fst[a*16+b]);
      '-' : dec(fst[a*16+b]);
      #13 : begin
        c:=a;
        d:=b;
        repeat
          writestr(41+d*2,6+c,$ac,' '+chr(c*16+d)+' ');
          ch:=readkey;
          if ch=#0 then
            begin
            writestr(41+d*2,6+c,$ec,' '+chr(c*16+d)+' ');
            ch:=readkey;
            case ch of
              #59 : help(1);
              #72 : c:=(c-1) and $f;
              #75 : d:=(d-1) and $f;
              #77 : d:=(d+1) and $f;
              #80 : c:=(c+1) and $f;
              end;
            end;
        until (ch=#13) or (ch=#27);
        if ch=#13 then fst[a*16+b]:=chr(c*16+d);
        writestr(41+d*2,6+c,$ec,' '+chr(c*16+d)+' ');
        ch:=#0;
        end;
      end;
    writestr(7+b*2,6+a,$b9,' '+fst[a*16+b]+' ');
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure filelister(searchfor,title:string;helpidx:byte;var filename:string);
  function str17(s:string):string;
  var
    a : byte;
  begin
    s:=' '+s;
    while length(s)<17 do s:=s+' ';
    str17:=s;
  end;
var
  scrdump  : array[0..3679] of byte;
  files    : array[0..2047] of string[12];
  search   : searchrec;
  fcount   : word;
  dircount : byte;
  path     : string;
  newdir   : boolean;
  listpos  : word;
  listpage : word;
  ch       : char;
  a        : byte;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  window3(25,4,55,21,title);
  for a:=6 to 19 do
    begin
    writestr(31,a,$e8,'');
    writechar(32,a,$7f,17,' ');
    writestr(49,a,$ef,'');
    end;
  getdir(0,path);
  if path[length(path)]<>'\' then path:=path+'\';
  newdir:=true;
  repeat
    if newdir then
      begin
      newdir:=false;
      fcount:=0;
      dircount:=0;
      findfirst(path+'*.*',directory,search);
      while doserror=0 do
        begin
        if (search.name<>'.') and (search.attr and directory=directory) then
          begin
          files[fcount]:=upstr(search.name);
          inc(fcount);
          inc(dircount);
          end;
        findnext(search);
        end;
      findfirst(path+searchfor,archive+hidden+sysfile+readonly,search);
      while doserror=0 do
        begin
        files[fcount]:=downstr(search.name);
        inc(fcount);
        findnext(search);
        end;
      listpos:=0;
      listpage:=0;
      writestr(32,6,$9f,str17(files[0]));
      for a:=1 to 13 do
        begin
        if a>=fcount then
          writestr(32,a+6,$7e,str17(''))
          else
          writestr(32,a+6,$7e,str17(files[listpage*14+a]));
        end;
      end;
    ch:=readkey;
    if ch=#0 then
      begin
      ch:=readkey;
      if ch=#73 then ch:=#75; { Bild hoch wie Cursor left }
      if ch=#81 then ch:=#77; { Bild runter wie Cursor right }
      case ch of
        #59 : help(helpidx);
        #72 : begin
          if listpage*14+listpos>0 then { Anfang der Liste? }
            begin
            if listpos>0 then
              begin
              writestr(32,listpos+6,$7e,str17(files[listpage*14+listpos]));
              dec(listpos);
              writestr(32,listpos+6,$9f,str17(files[listpage*14+listpos]));
              end
              else
              begin
              dec(listpage);
              listpos:=13;
              writestr(32,6+13,$9f,str17(files[listpage*14+listpos]));
              for a:=0 to 12 do
                writestr(32,a+6,$7e,str17(files[listpage*14+a]));
              end;
            end;
          end;
        #80 : begin
          if listpage*14+listpos+1<fcount then { Ende der Liste? }
            begin
            if listpos<13 then
              begin
              writestr(32,listpos+6,$7e,str17(files[listpage*14+listpos]));
              inc(listpos);
              writestr(32,listpos+6,$9f,str17(files[listpage*14+listpos]));
              end
              else
              begin
              inc(listpage);
              listpos:=0;
              writestr(32,6,$9f,str17(files[listpage*14+listpos]));
              for a:=1 to 13 do
                begin
                if listpage*14+a>=fcount then
                  writestr(32,a+6,$7e,str17(''))
                  else
                  writestr(32,a+6,$7e,str17(files[listpage*14+a]));
                end;
              end;
            end;
          end;
        #75 : begin
          if listpage>0 then { existiert vorherige Seite? }
            begin
            dec(listpage);
            listpos:=0;
            writestr(32,6,$9f,str17(files[listpage*14+listpos]));
            for a:=1 to 13 do
              writestr(32,a+6,$7e,str17(files[listpage*14+a]));
            end;
          end;
        #77 : begin
          if (listpage+1)*14<fcount then { existiert nchste Seite? }
            begin
            inc(listpage);
            listpos:=0;
            writestr(32,6,$9f,str17(files[listpage*14+listpos]));
            for a:=1 to 13 do
              begin
              if listpage*14+a>=fcount then
                writestr(32,a+6,$7e,str17(''))
                else
                writestr(32,a+6,$7e,str17(files[listpage*14+a]));
              end;
            end;
          end;
        end; { von Case }
      end
      else
      begin { ch kein Sonderzeichen }
      if ch=#13 then
        begin
        if listpage*14+listpos<dircount then
          begin { Directory-Wechsel }
          newdir:=true;
          if files[listpage*14+listpos]<>'..' then
            path:=path+files[listpage*14+listpos]+'\'
            else
            begin
            for a:=length(path)-1 downto 1 do if path[a]='\' then break;
            path:=copy(path,1,a);
            end;
          end
          else
          begin { Datei-Auswahl }
          filename:=upstr(path+files[listpage*14+listpos]);
          ch:=#27; { Taste zum Beenden simulieren }
          end;
        end;
      end;
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure colordialog(title:string;helpidx:byte;var color:byte);
var
  scrdump : array[0..3679] of byte;
  a,b     : byte;
  ch      : char;
  blink   : boolean;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  window3(14,3,66,22,title);
  for a:=0 to 15 do
    for b:=0 to 7 do writestr(b*6+17,a+6,a+b*16,'iCode');
  a:=color mod 16;
  b:=(trunc(color/16)) and $7;
  writestr(b*6+16,a+6,$e9,'');
  writestr(b*6+22,a+6,$e9,'');
  writestr(17,5,$e8,'[ ] Blink  (An/Aus mit Space)');
  blink:=false;
  if color and $80=$80 then
    begin
    writestr(18,5,$e8,'X');
    blink:=true;
    end;
  repeat
    ch:=readkey;
    if ch=#0 then
      begin
      ch:=readkey;
      writestr(b*6+16,a+6,$e9,' ');
      writestr(b*6+22,a+6,$e9,' ');
      case ch of
        #59 : help(helpidx);
        #72 : a:=(a-1) and $f;
        #75 : b:=(b-1) and $7;
        #77 : b:=(b+1) and $7;
        #80 : a:=(a+1) and $f;
        end;
      writestr(b*6+16,a+6,$e9,'');
      writestr(b*6+22,a+6,$e9,'');
      ch:=#0;
      end;
    case ch of
      #32 : begin
        blink:=not blink;
        if blink then writestr(18,5,$e8,'X') else writestr(18,5,$e8,' ')
        end;
      #13 : begin
        color:=b*16+a;
        if blink then color:=color or $80;
        ch:=#27; { Ende simulieren }
        end;
      end;
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure asc2table(title:string;helpidx:byte;var asc2ch:char);
var
  scrdump : array[0..3679] of byte;
  a,b     : byte;
  ch      : char;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  window3(22,4,58,22,title);
  for a:=0 to 15 do
    for b:=0 to 15 do writestr(b*2+25,a+6,$e9,chr(a*16+b));
  a:=trunc(ord(asc2ch)/16);
  b:=ord(asc2ch) mod 16;
  writestr(b*2+24,a+6,$b9,' '+chr(a*16+b)+' ');
  repeat
    ch:=readkey;
    if ch=#0 then
      begin
      ch:=readkey;
      writestr(b*2+24,a+6,$e9,' '+chr(a*16+b)+' ');
      case ch of
        #59 : help(helpidx);
        #72 : a:=(a-1) and $f;
        #75 : b:=(b-1) and $f;
        #77 : b:=(b+1) and $f;
        #80 : a:=(a+1) and $f;
        end;
      writestr(b*2+24,a+6,$b9,' '+chr(a*16+b)+' ');
      ch:=#0;
      end;
    if ch=#13 then
      begin
      asc2ch:=chr(a*16+b);
      ch:=#27; { Ende simulieren }
      end;
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure lister(lst:array of str20;title:string;helpidx:byte;var lpos:byte);
var
  scrdump : array[0..3679] of byte;
  lstcnt  : byte;
  width   : byte;
  x,y     : byte;
  a       : byte;
  ch      : char;
  i       : byte;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  lstcnt:=sizeof(lst) div sizeof(str20);
  width:=length(title)+7;
  for a:=0 to lstcnt-1 do if length(lst[a])+4>width then width:=length(lst[a])+4;
  x:=(80-width) shr 1;
  y:=(23-lstcnt) shr 1;
  window2(x,y,x+width,y+lstcnt+2,title);
  for i := y+1 to y+lstcnt+3 do writechar(x+width+1,i,$19,1,'');
  writechar(x+1,y+lstcnt+3,$19,width,'');
  for a:=0 to lstcnt-1 do writestr(40-(length(lst[a]) shr 1),y+2+a,$de,lst[a]);
  if lpos>lstcnt-1 then a:=0 else a:=lpos;
  writechar(x+1,y+2+a,$9f,39-x-length(lst[a]) shr 1,' ');
  writestr(40-(length(lst[a]) shr 1),y+2+a,$9f,lst[a]);
  writechar(40+((length(lst[a])+1) shr 1),y+2+a,$9f,x+width-40-(length(lst[a])+1) shr 1,' ');
  lPos := 0;
  repeat
    ch:=readkey;
    if ch=#0 then
      begin
      ch:=readkey;
      writechar(x+1,y+2+a,$de,39-x-length(lst[a]) shr 1,' ');
      writestr(40-(length(lst[a]) shr 1),y+2+a,$de,lst[a]);
      writechar(40+((length(lst[a])+1) shr 1),y+2+a,$de,x+width-40-(length(lst[a])+1) shr 1,' ');
      case ch of
        #59 : help(helpidx);
        #71 : a:=0;
        #72 : if a>0 then dec(a) else a:=lstcnt-1;
        #79 : a:=lstcnt-1;
        #80 : if a<lstcnt-1 then inc(a) else a:=0;
        end;
      writechar(x+1,y+2+a,$9f,39-x-length(lst[a]) shr 1,' ');
      writestr(40-(length(lst[a]) shr 1),y+2+a,$9f,lst[a]);
      writechar(40+((length(lst[a])+1) shr 1),y+2+a,$9f,x+width-40-(length(lst[a])+1) shr 1,' ');
      ch:=#0;
      end;
    if ch=#13 then
      begin
      lpos:=a;
      ch:=#27; { Ende simulieren }
      end;
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure counter(min,max:byte;title:string;helpidx:byte;var value : byte);
  function int2str(i:integer):string;
  var
    s : string;
  begin
    str(i:4,s);
    int2str:=s;
  end;
var
  scrdump : array[0..3679] of byte;
  ch      : char;
  a       : byte;
begin
  move(ptr($b800,160)^,scrdump,sizeof(scrdump));
  window3(21,10,59,14,title);
  writechar(23,12,$e9,31,'');
  a:=value;
  if a>max then a:=max;
  if a<min then a:=min;
  repeat
    writestr(23+round((a-min)*30/(max-min)),12,$e9,'');
    writestr(54,12,$e9,int2str(a));
    ch:=readkey;
    writestr(23+round((a-min)*30/(max-min)),12,$e9,'');
    if ch=#0 then
      begin
      ch:=readkey;
      case ch of
        #59 : help(helpidx);
        #71 : a:=min;
        #73 : if a+10<=max then a:=a+10 else a:=max;
        #75,#80 : if a>min then dec(a);
        #77,#72 : if a<max then inc(a);
        #79 : a:=max;
        #81 : if a>=min+10 then a:=a-10 else a:=min;
        end;
      ch:=#0;
      end
      else
      begin
      case ch of
        '+' : if a<max then inc(a);
        '-' : if a>min then dec(a);
        #13 : begin
          value:=a;
          ch:=#27; { Emnde simulieren }
          end;
        end;
      end;
  until ch=#27;
  move(scrdump,ptr($b800,160)^,sizeof(scrdump));
end;

procedure initconfig;
begin
  textmode(co80);
  port[$3c0]:=$30;
  port[$3c0]:=$4;
  portw[$3d4]:=$200a;
  writechar(1,1,$19,2000,'');

  writestr(1,1,$de,'۲ iCall Configuration Editor Revision '+rev+' ');
  writestr(51,1,$19,'');
  writechar(2,2,$19,50,'');
  writestr(37,25,$de,'۲ Call da MilchBOX BBS -> o6o42-56o ');
end;


procedure biglist( cfgname : string );
label goAgain;
type
  lineentry = record
     name   : string[43];
     value  : string[30];
     active : boolean;
    end;
const
  maxline = 64;
  lines : array[0..maxline] of lineentry =
{00}((name:'Verzeichnis von RA.LOG';value:'C:\RA\RA.LOG';active:true),
{01} (name:'Hintergrund Ansi';value:'NONE';active:true),
{02} (name:'Anzahl der aufgefhrten User';value:'10';active:true),
{03} (name:'Anfangszeile der Liste';value:'5';active:true),
{04} (name:'Font-Substitution Table';value:'...';active:true),
{05} (name:'';value:'';active:false),
{06} (name:'Namen des Users anzeigen';value:'ja';active:true),
{07} (name:'Handle verwenden statt Usernamen';value:'nein';active:false),
{08} (name:'X-Position des Namens';value:'5';active:true),
{09} (name:'maximale Lnge des Namens';value:'20';active:true),
{10} (name:'Farbe fr Usernamen';value:'Papyruswei auf Schwarz';active:true),
{11} (name:'';value:'';active:false),
{12} (name:'Wohnort des Users anzeigen';value:'ja';active:false),
{13} (name:'X-Position des Wohnortes';value:'25';active:false),
{14} (name:'maximale Lnge des Ortes';value:'10';active:false),
{15} (name:'Farbe fr Wohnort';value:'Papyruswei auf Schwarz';active:false),
{16} (name:'';value:'';active:false),
{17} (name:'Baudrate der Verbindung anzeigen';value:'ja';active:true),
{18} (name:'X-Position der Baudrate';value:'35';active:true),
{19} (name:'Format der Baud-Angabe';value:'28.8';active:true),
{20} (name:'Farbe fr Baud-Angabe';value:'Papyruswei auf Schwarz';active:true),
{21} (name:'';value:'';active:false),
{22} (name:'Anfangszeit der Verbindung anzeigen';value:'ja';active:true),
{23} (name:'X-Position der Anfangszeit';value:'43';active:true),
{24} (name:'Format der Zeitangabe';value:'HH:MM';active:true),
{25} (name:'Farbe fr Anfangszeit';value:'Papyruswei auf Schwarz';active:true),
{26} (name:'';value:'';active:false),
{27} (name:'Ende der Verbindung anzeigen';value:'ja';active:true),
{28} (name:'X-Position der Endzeit';value:'49';active:true),
{29} (name:'Format der Zeitangabe';value:'HH:MM';active:true),
{30} (name:'Farbe fr Endzeit';value:'Papyruswei auf Schwarz';active:true),
{31} (name:'';value:'';active:false),
{32} (name:'Onlinezeit anzeigen';value:'ja';active:true),
{33} (name:'X-Position der Onlinezeit';value:'55';active:true),
{34} (name:'Format der Onlinezeitangabe';value:'MMM';active:true),
{35} (name:'Farbe fr Onlinezeit';value:'Papyruswei auf Schwarz';active:true),
{36} (name:'';value:'';active:false),
{37} (name:'Verbindungsdatum anzeigen';value:'ja';active:true),
{38} (name:'X-Position des Datums';value:'55';active:true),
{39} (name:'Format des Datums';value:'TT.MM.';active:true),
{40} (name:'Farbe der Datumsangabe';value:'Papyruswei auf Schwarz';active:true),
{41} (name:'';value:'';active:false),
{42} (name:'Verbindunsabbruch (Bad Logoff) anzeigen';value:'ja';active:true),
{43} (name:'X-Position des Bad-Logoff-Flags';value:'57';active:true),
{44} (name:'ASCII-Zeichen';value:'B';active:true),
{45} (name:'Farbe des Flags';value:'Papyruswei auf Schwarz';active:true),
{46} (name:'';value:'';active:false),
{47} (name:'Message-Schreiben anzeigen';value:'ja';active:true),
{48} (name:'X-Position von MSG-Write';value:'59';active:true),
{49} (name:'ASCII-Zeichen';value:'W';active:true),
{50} (name:'Farbe des Flags';value:'Papyruswei auf Schwarz';active:true),
{51} (name:'Message-Lesen anzeigen';value:'ja';active:true),
{52} (name:'X-Position von MSG-Read';value:'61';active:true),
{53} (name:'ASCII-Zeichen';value:'R';active:true),
{54} (name:'Farbe des Flags';value:'Papyruswei auf Schwarz';active:true),
{55} (name:'';value:'';active:false),
{56} (name:'Upload anzeigen';value:'ja';active:true),
{57} (name:'X-Position von Upload';value:'63';active:true),
{58} (name:'ASCII-Zeichen';value:'U';active:true),
{59} (name:'Farbe des Flags';value:'Papyruswei auf Schwarz';active:true),
{60} (name:'';value:'';active:false),
{61} (name:'Download anzeigen';value:'ja';active:true),
{62} (name:'X-Position von Download';value:'65';active:true),
{63} (name:'ASCII-Zeichen';value:'D';active:true),
{64} (name:'Farbe des Flags';value:'Papyruswei auf Schwarz';active:true));
  config : configtype = (header:hdrbytes;ralogDir:'C:\RA\RA.LOG';backgroundansi:'';usercount:10;
    firstline:5;fontsubsttab:'';username:true;usehandle:false;xposuser:5;
    lengthuser:20;coloruser:15;location:true;xposlocation:25;lengthlocation:10;
    colorlocation:15;baudrate:true;xposbaudrate:35;formatbaudrate:0;
    colorbaudrate:15;stime:true;xposstime:43;formatstime:0;colorstime:15;
    etime:true;xposetime:49;formatetime:0;coloretime:15;online:true;
    xposonline:55;formatonline:0;coloronline:15;date:true;xposdate:55;
    formatdate:5;colordate:15;badl:true;xposbadl:57;asc2badl:'B';colorbadl:15;
    write:true;xposwrite:59;asc2write:'W';colorwrite:15;read:true;xposread:61;
    asc2read:'R';colorread:15;upload:true;xposupload:63;asc2upload:'U';
    colorupload:15;download:true;xposdownload:65;asc2download:'D';
    colordownload:15);
var
  page  : byte;
  line  : byte;
  np,nl : byte;
  ch    : char;
  a     : byte;
  cfgf  : file of configtype;
  function int2str(i:longint):string;
  var
    s : string;
  begin
    str(i,s);
    int2str:=s;
  end;
  function rightstr(s:string):string;
  var
    a : byte;
  begin
    while length(s)<30 do s:=' '+s;
    rightstr:=s;
  end;
  function str43(s:string):string;
  var
    a : byte;
  begin
    while length(s)<43 do s:=s+' ';
    str43:=s;
  end;
  function int2color(color:byte):string;
  const
    colornames : array[0..15] of str20 = ('Schwarz','Kobaltblau','Schilfgrn',
      'Azurblau','Titzianrot','Purpurviolett','Kaminrot','Delphingrau',
      'Anthrazit','Knigsblau','Heugrn','Himmelblau','Koralle','Erika',
      'Sommergelb','Papyruswei');
  var
    s : string;
  begin
    if color and $80=$80 then s:='[B] ' else s:='';
    s:=s+colornames[color and $f]+' auf '+colornames[(color shr 4) and $7];
    int2color:=s;
  end;
  procedure redraw;
  var
    a : byte;
  begin
    for a:=0 to 16 do
      begin
      if page*17+a>maxline then
        begin
        writestr(3,a+5,$e7,' '+str43(''));
        writestr(47,a+5,$e7,rightstr('')+' ');
        end
        else
        begin
        if lines[page*17+a].active=true then
          begin
          if a=line then
            begin
            writestr(3,a+5,$9f,' '+str43(lines[page*17+a].name));
            writestr(47,a+5,$9f,rightstr(lines[page*17+a].value)+' ');
            end
            else
            begin
            writestr(3,a+5,$e5,' '+str43(lines[page*17+a].name));
            writestr(47,a+5,$e5,rightstr(lines[page*17+a].value)+' ');
            end;
          end
          else
          begin
          writestr(3,a+5,$e7,' '+str43(lines[page*17+a].name));
          writestr(47,a+5,$e7,rightstr(lines[page*17+a].value)+' ');
          end;
        end;
      end;
  end;
  procedure recalc;
  begin
    lines[0].value := config.ralogDir;
    if config.backgroundansi='' then lines[1].value:='NONE'
      else lines[1].value:=config.backgroundansi;
    lines[2].value:=int2str(config.usercount);
    lines[3].value:=int2str(config.firstline);
    if config.username=true then
    begin
      lines[6].value:='ja';
      lines[7].active:=true;
      lines[8].active:=true;
      lines[9].active:=true;
      lines[10].active:=true;
    end
    else
    begin
      lines[6].value:='nein';
      lines[7].active:=false;
      lines[8].active:=false;
      lines[9].active:=false;
      lines[10].active:=false;
    end;
    if config.usehandle=true then lines[7].value:='ja' else lines[7].value:='nein';
    lines[8].value:=int2str(config.xposuser);
    lines[9].value:=int2str(config.lengthuser);
    lines[10].value:=int2color(config.coloruser);
    if config.location=true then
    begin
      lines[12].value:='ja';
      lines[12].active:=true;
      lines[13].active:=true;
      lines[14].active:=true;
      lines[15].active:=true;
    end
    else
    begin
      lines[12].value:='nein';
      lines[12].active:=true;
      lines[13].active:=false;
      lines[14].active:=false;
      lines[15].active:=false;
      end;
    lines[13].value:=int2str(config.xposlocation);
    lines[14].value:=int2str(config.lengthlocation);
    lines[15].value:=int2color(config.colorlocation);
    if config.baudrate=true then
      begin
      lines[17].value:='ja';
      lines[18].active:=true;
      lines[19].active:=true;
      lines[20].active:=true;
      end
      else
      begin
      lines[17].value:='nein';
      lines[18].active:=false;
      lines[19].active:=false;
      lines[20].active:=false;
      end;
    lines[18].value:=int2str(config.xposbaudrate);
    lines[19].value:=baudrate[config.formatbaudrate];
    lines[20].value:=int2color(config.colorbaudrate);
    if config.stime=true then
      begin
      lines[22].value:='ja';
      lines[23].active:=true;
      lines[24].active:=true;
      lines[25].active:=true;
      end
      else
      begin
      lines[22].value:='nein';
      lines[23].active:=false;
      lines[24].active:=false;
      lines[25].active:=false;
      end;
    lines[23].value:=int2str(config.xposstime);
    lines[24].value:=timerec[config.formatstime];
    lines[25].value:=int2color(config.colorstime);
    if config.etime=true then
      begin
      lines[27].value:='ja';
      lines[28].active:=true;
      lines[29].active:=true;
      lines[30].active:=true;
      end
      else
      begin
      lines[27].value:='nein';
      lines[28].active:=false;
      lines[29].active:=false;
      lines[30].active:=false;
      end;
    lines[28].value:=int2str(config.xposetime);
    lines[29].value:=timerec[config.formatetime];
    lines[30].value:=int2color(config.coloretime);
    if config.online=true then
      begin
      lines[32].value:='ja';
      lines[33].active:=true;
      lines[34].active:=true;
      lines[35].active:=true;
      end
      else
      begin
      lines[32].value:='nein';
      lines[33].active:=false;
      lines[34].active:=false;
      lines[35].active:=false;
      end;
    lines[33].value:=int2str(config.xposonline);
    lines[34].value:=online[config.formatonline];
    lines[35].value:=int2color(config.coloronline);
    if config.date=true then
      begin
      lines[37].value:='ja';
      lines[38].active:=true;
      lines[39].active:=true;
      lines[40].active:=true;
      end
      else
      begin
      lines[37].value:='nein';
      lines[38].active:=false;
      lines[39].active:=false;
      lines[40].active:=false;
      end;
    lines[38].value:=int2str(config.xposdate);
    lines[39].value:=daterec[config.formatdate];
    lines[40].value:=int2color(config.colordate);
    if config.badl=true then
      begin
      lines[42].value:='ja';
      lines[43].active:=true;
      lines[44].active:=true;
      lines[45].active:=true;
      end
      else
      begin
      lines[42].value:='nein';
      lines[43].active:=false;
      lines[44].active:=false;
      lines[45].active:=false;
      end;
    lines[43].value:=int2str(config.xposbadl);
    lines[44].value:=''+config.asc2badl+'';
    lines[45].value:=int2color(config.colorbadl);
    if config.write=true then
      begin
      lines[47].value:='ja';
      lines[48].active:=true;
      lines[49].active:=true;
      lines[50].active:=true;
      end
      else
      begin
      lines[47].value:='nein';
      lines[48].active:=false;
      lines[49].active:=false;
      lines[50].active:=false;
      end;
    lines[48].value:=int2str(config.xposwrite);
    lines[49].value:=''+config.asc2write+'';
    lines[50].value:=int2color(config.colorwrite);
    if config.read=true then
      begin
      lines[51].value:='ja';
      lines[52].active:=true;
      lines[53].active:=true;
      lines[54].active:=true;
      end
      else
      begin
      lines[51].value:='nein';
      lines[52].active:=false;
      lines[53].active:=false;
      lines[54].active:=false;
      end;
    lines[52].value:=int2str(config.xposread);
    lines[53].value:=''+config.asc2read+'';
    lines[54].value:=int2color(config.colorread);
    if config.upload=true then
      begin
      lines[56].value:='ja';
      lines[57].active:=true;
      lines[58].active:=true;
      lines[59].active:=true;
      end
      else
      begin
      lines[56].value:='nein';
      lines[57].active:=false;
      lines[58].active:=false;
      lines[59].active:=false;
      end;
    lines[57].value:=int2str(config.xposupload);
    lines[58].value:=''+config.asc2upload+'';
    lines[59].value:=int2color(config.colorupload);
    if config.download=true then
    begin
      lines[61].value:='ja';
      lines[62].active:=true;
      lines[63].active:=true;
      lines[64].active:=true;
    end
    else
    begin
      lines[61].value:='nein';
      lines[62].active:=false;
      lines[63].active:=false;
      lines[64].active:=false;
    end;
    lines[62].value:=int2str(config.xposdownload);
    lines[63].value:=''+config.asc2download+'';
    lines[64].value:=int2color(config.colordownload);
  end;
  procedure delete(lpos:word);
  begin
    case lpos of
      0 : config.ralogDir := 'C:\RA\RA.LOG';
      1 : config.backgroundansi:='';
      end;
    recalc;
    redraw;
  end;
  procedure enter(lpos:word);
  begin
    case lpos of
      00 : filelister('RA.LOG','RA-Logfile',42,config.ralogdir);
      01 : filelister('*.ANS','Hintergrund-ANSI',2,config.backgroundansi);
      02 : counter(1,15,'Anzahl der User',3,config.usercount);
      03 : counter(1,25,'erste Zeile',4,config.firstline);
      04 : fontsubstitution(config.fontsubsttab);
      06 : config.username:=not config.username;
      07 : config.usehandle:=not config.usehandle;
      08 : counter(1,80,'X-Position USERNAME',6,config.xposuser);
      09 : counter(1,80,'Lnge USERNAME',7,config.lengthuser);
      10 : colordialog('Farbe von USERNAME',8,config.coloruser);
      12 : config.location:=not config.location;
      13 : counter(1,80,'X-Position LOCATION',9,config.xposlocation);
      14 : counter(1,80,'Lnge LOCATION',10,config.lengthlocation);
      15 : colordialog('Farbe von LOCATION',11,config.colorlocation);
      17 : config.baudrate:=not config.baudrate;
      18 : counter(1,80,'X-Position BAUDRATE',12,config.xposbaudrate);
      19 : lister(baudrate,'Format von LOCATION',13,config.formatbaudrate);
      20 : colordialog('Farbe von BAUDRATE',14,config.colorbaudrate);
      22 : config.stime:=not config.stime;
      23 : counter(1,80,'X-Position STARTZEIT',15,config.xposstime);
      24 : lister(timerec,'Format von STARTZEIT',16,config.formatstime);
      25 : colordialog('Farbe von STARTZEIT',17,config.colorstime);
      27 : config.etime:=not config.etime;
      28 : counter(1,80,'X-Position ENDZEIT',18,config.xposetime);
      29 : lister(timerec,'Format von ENDZEIT',19,config.formatetime);
      30 : colordialog('Farbe von ENDZEIT',20,config.coloretime);
      32 : config.online:=not config.online;
      33 : counter(1,80,'X-Position ONLINEZEIT',21,config.xposonline);
      34 : lister(online,'Format von ONLINEZEIT',22,config.formatonline);
      35 : colordialog('Farbe von ONLINEZEIT',23,config.coloronline);
      37 : config.date:=not config.date;
      38 : counter(1,80,'X-Position DATUM',24,config.xposdate);
      39 : lister(daterec,'Format von DATUM',25,config.formatdate);
      40 : colordialog('Farbe von DATUM',26,config.colordate);
      42 : config.badl:=not config.badl;
      43 : counter(1,80,'X-Position BAD LOGOFF',27,config.xposbadl);
      44 : asc2table('ASCII-Zeichen BAD LOGOFF',28,config.asc2badl);
      45 : colordialog('Farbe von BAD LOGOFF',29,config.colorbadl);
      47 : config.write:=not config.write;
      48 : counter(1,80,'X-Position WRITE MSG',30,config.xposwrite);
      49 : asc2table('ASCII-Zeichen WRITE MSG',31,config.asc2write);
      50 : colordialog('Farbe von WRITE MSG',32,config.colorwrite);
      51 : config.read:=not config.read;
      52 : counter(1,80,'X-Position READ MSG',33,config.xposread);
      53 : asc2table('ASCII-Zeichen READ MSG',34,config.asc2read);
      54 : colordialog('Farbe von READ MSG',35,config.colorread);
      56 : config.upload:=not config.upload;
      57 : counter(1,80,'X-Position UPLOAD',36,config.xposupload);
      58 : asc2table('ASCII-Zeichen UPLOAD',37,config.asc2upload);
      59 : colordialog('Farbe von UPLOAD',38,config.colorupload);
      61 : config.download:=not config.download;
      62 : counter(1,80,'X-Position DOWNLOAD',39,config.xposdownload);
      63 : asc2table('ASCII-Zeichen DOWNLOAD',40,config.asc2download);
      64 : colordialog('Farbe von DOWNLOAD',41,config.colordownload);
    end;
    recalc;
    redraw;
  end;
begin
  for a:=0 to 255 do config.fontsubsttab[a]:=chr(a);
  if cfgname = '' then
    assign(cfgf,'ICALL.DAT')
    else
    assign(cfgf,cfgname);

  {$I-} reset(cfgf); {$I+}
  if ioresult<>0 then
  begin
    {$I-} rewrite(cfgf); {$I+}
    if ioresult <> 0 then error(1);
  end
  else
  begin
    {$i-} read(cfgf,config); {$i+}
    if ioresult <> 0 then error(2);
    if config.header <> hdrbytes then error(2);
  end;
  close(cfgf);

  goAgain:


  window(2,3,78,22,'Konfiguriere iCall');
  page:=0;
  line:=0;
  recalc;
  redraw;
  repeat
    ch:=readkey;
    if ch=#0 then
      begin
      ch:=readkey;
      case ch of
        #59 : help(0);
        #72 : begin
          a:=page*17+line;
          while a>0 do
            begin
            dec(a);
            if lines[a].active=true then
              begin
              np:=trunc(a/17);
              nl:=a mod 17;
              if np=page then
                begin
                writestr(3,5+line,$e5,' '+str43(lines[page*17+line].name));
                writestr(47,5+line,$e5,rightstr(lines[page*17+line].value)+' ');
                writestr(3,5+nl,$9f,' '+str43(lines[np*17+nl].name));
                writestr(47,5+nl,$9f,rightstr(lines[np*17+nl].value)+' ');
                page:=np;
                line:=nl;
                end
                else
                begin
                page:=np;
                line:=nl;
                redraw;
                end;
              break;
              end;
            end;
          end;
        #80 : begin
          a:=page*17+line;
          while a<maxline do
            begin
            inc(a);
            if lines[a].active=true then
              begin
              np:=trunc(a/17);
              nl:=a mod 17;
              if np=page then
                begin
                writestr(3,5+line,$e5,' '+str43(lines[page*17+line].name));
                writestr(47,5+line,$e5,rightstr(lines[page*17+line].value)+' ');
                writestr(3,5+nl,$9f,' '+str43(lines[np*17+nl].name));
                writestr(47,5+nl,$9f,rightstr(lines[np*17+nl].value)+' ');
                page:=np;
                line:=nl;
                end
                else
                begin
                page:=np;
                line:=nl;
                redraw;
                end;
              break;
              end;
            end;
          end;
        #83 : delete(page*17+line);
        end; { von case ch }
      ch:=#0;
      end;
    if ch=#13 then enter(page*17+line);
  until ch=#27;
  clearscreen;
  lister(save,'iCall Beenden',0,a);
  if a = 0 then goto goAgain;
  if a=1 then
  begin
    rewrite(cfgf);
    write(cfgf,config);
    close(cfgf);
  end;
end;

procedure getPhysByte( c : word );
var bytes2read : word;
begin
  { fALCON: kopiert Restbytes vom Anfang des Puffers an das Ende des
            Puffers }
  asm
    mov ax, ds
    mov es, ax

    db 66h; xor ax,ax
    mov ax, c
    db 66h; cmp word ptr filepos, ax
    jae @ganznormallesen

    mov ax,word ptr filepos
    or  ax, ax
    jz  @startReached
  @ganznormallesen:
    mov cx,buffersize
    sub cx,ax

    mov si, offset buffer
    mov di, si
    add di, ax

    rep movsb
  @startReached:

    mov bytes2read, ax
  end;

  seek( logfile ,  filepos - bytes2read );
  blockread( logfile , buffer  , bytes2read );
  filepos := filepos - bytes2read;
  bufpos := bufPos + bytes2read;
end;

procedure readline;
var exitall : boolean;
begin
  if bufpos < 256 then getPhysByte( buffersize-bufpos );
  exitAll := false;

  { fALCON: Nach dem Beginn der Zeile suchen (ASCII 13) }

  asm
    xor dx, dx
    mov si, offset buffer
    mov bx, bufPos
    dec bx
    mov cx, 256
  @searchBackward:
    cmp byte ptr [si+bx], 13d
    je @foundLine

    dec cx
    jz  @lineNotFound

    or  bx, bx
    js  @foundfirstLine
    dec bx

    jmp @searchBackward

  @lineNotFound:
    mov exitAll, 1
    jmp @gehWeg

  @foundline:
    inc dx
    inc dx
  @foundFirstLine:
    inc cx

    mov ax, ds
    mov es, ax
    mov di, offset actStr
    add si, bx
    add si, dx
    mov ax, 256
    sub ax, cx
    mov cx, ax

    mov byte ptr [di], cl
    inc di

    rep movsb

    add ax, dx
    sub bufPos, ax

  @gehWeg:
  end;
  if exitAll then halt;
end;

procedure config( cfgname : string );
begin
  initConfig;
  bigList( cfgname );
  textmode(lastmode);
  writeln;
  writeln(' iCode ICALL configuration editor');
  writeln('  ... all done!');
  writeln;
  halt;
end;

procedure init;
var f   : file;
    buf : string[32];
begin
  filemode:=0;

  if (paramstr(1)='/c') or (paramstr(1)='/C') then config(paramstr(2));
  if (paramstr(2)='/c') or (paramstr(2)='/C') then config(paramstr(1));

  { Kommandozeilen-Parameter berprfen... }
  if paramstr(1) <> '' then
  begin
    assign( f , paramstr(1) );
    {$i-} reset(f,1); {$i+}
    if ioresult = 0 then
    begin
      {$i-} blockread( f , buf , sizeof(buf) ); {$i+}
      if ioresult = 0 then
      begin
        if buf = hdrbytes then
        begin
          close( f );
          config( paramstr(1) );
        end;
      end;
      close( f );
    end;
  end;

  if paramstr(1) <> '' then logfilename := paramstr(1);
  assign( logfile , logfilename );
  {$i-} reset( logfile , 1 ); {$i+}
  if ioresult <> 0 then error(3);
  filepos := filesize( logfile );
  bufPos := 0;
  writeln('> iCode ICALL rev '+rev+' ALPHA <');
  writeln;
  writeln('  code by esdimax / fALCON 1997');
  writeln('  generating C:\ICALL.ANS...');
  writeln;
end;

procedure done;
begin
  close( logfile );
end;

procedure getSdatetime; assembler;
asm
  { Tag in Byte konvertieren }
  mov si,offset actstr
  mov al,[si+3]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+4]
  sub al,16
  mov actentry.stag,al

  { Stunde in Byte }
  mov al,[si+10]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+11]
  sub al,16
  mov actentry.shour,al

  { Minute in Byte }
  mov al,[si+13]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+14]
  sub al,16
  mov actentry.smin,al

  db 66h; mov ax,[si+5]
  xor bl,bl
  inc bl
  db 66h, 3dh, '-Jan'
  je @found
  inc bl
  db 66h, 3dh, '-Feb'
  je @found
  inc bl
  db 66h, 3dh, '-Mar'
  je @found
  db 66h, 3dh, '-Mr'
  je @found
  inc bl
  db 66h, 3dh, '-Apr'
  je @found
  inc bl
  db 66h, 3dh, '-May'
  je @found
  db 66h, 3dh, '-Mai'
  je @found
  inc bl
  db 66h, 3dh, '-Jun'
  je @found
  inc bl
  db 66h, 3dh, '-Jul'
  je @found
  inc bl
  db 66h, 3dh, '-Aug'
  je @found
  inc bl
  db 66h, 3dh, '-Sep'
  je @found
  inc bl
  db 66h, 3dh, '-Oct'
  je @found
  db 66h, 3dh, '-Okt'
  je @found
  inc bl
  db 66h, 3dh, '-Nov'
  je @found
  inc bl
  db 66h, 3dh, '-Dec'
  je @found
  db 66h, 3dh, '-Dez'
  je @found
  xor bl,bl
@found:
  mov actentry.smonat,bl
end;
procedure getEdatetime; assembler;
asm
  { Tag in Byte konvertieren }
  mov si,offset actstr
  mov al,[si+3]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+4]
  sub al,16
  mov actentry.etag,al

  { Stunde in Byte }
  mov al,[si+10]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+11]
  sub al,16
  mov actentry.ehour,al

  { Minute in Byte }
  mov al,[si+13]
  mov ah,al
  shl al,3
  shl ah,1
  add al,ah
  add al,[si+14]
  sub al,16
  mov actentry.emin,al

  db 66h; mov ax,[si+5]
  xor bl,bl
  inc bl
  db 66h, 3dh, '-Jan'
  je @found
  inc bl
  db 66h, 3dh, '-Feb'
  je @found
  inc bl
  db 66h, 3dh, '-Mar'
  je @found
  db 66h, 3dh, '-Mr'
  je @found
  inc bl
  db 66h, 3dh, '-Apr'
  je @found
  inc bl
  db 66h, 3dh, '-May'
  je @found
  db 66h, 3dh, '-Mai'
  je @found
  inc bl
  db 66h, 3dh, '-Jun'
  je @found
  inc bl
  db 66h, 3dh, '-Jul'
  je @found
  inc bl
  db 66h, 3dh, '-Aug'
  je @found
  inc bl
  db 66h, 3dh, '-Sep'
  je @found
  inc bl
  db 66h, 3dh, '-Oct'
  je @found
  db 66h, 3dh, '-Okt'
  je @found
  inc bl
  db 66h, 3dh, '-Nov'
  je @found
  inc bl
  db 66h, 3dh, '-Dec'
  je @found
  db 66h, 3dh, '-Dez'
  je @found
  xor bl,bl
@found:
  mov actentry.emonat,bl
end;

function checkforbadlogoff:byte; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'sU'; db 'er'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+29d],'fo'; db 'f-'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function checkforbadlogoff2:byte; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'sU'; db 'er'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+29d],'er'; db 'qu'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function checkforUpload:boolean; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'pU'; db 'lo'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+28d],'da'; db ' ['
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function checkforDownload:boolean; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'oD'; db 'wn'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+28d],'ol'; db 'ad'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function msgwrite:boolean; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'eM'; db 'ss'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+37d],'op'; db 'st'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function msgread:boolean; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'eR'; db 'ad'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+32d],'em'; db 'ss'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function checkforSecurity:boolean; assembler;
asm
  mov si,offset actstr
  db 66h; cmp word ptr [si+24d],'eS'; db 'cu'
  db 0fh, 94h, 0c4h                     { sete ah }

  db 66h; cmp word ptr [si+28d],'ir'; db 'ty'
  db 0fh, 94h, 0c0h                     { sete al }
  and al, ah
end;

function checkforLogon:boolean; assembler;
asm
  mov si,offset actstr
  mov al, [si]
  cmp al, 5
  jb @lineToShort
  xor ah, ah
  add si, ax
  dec si
  dec si
  dec si
  db 66h; cmp word ptr [si],'B '; db 'PS'
  je @go
  xor al, al
  jmp @lineToShort
@go:
  { now check for Baud rate ... }
  dec si
@_loop:
  dec si
  cmp byte ptr [si], 32
  jne @_loop
  inc si
  mov ax, ds
  mov es, ax
  mov di, offset actentry.baud+1
  mov byte ptr [di-1], 0
  mov cx, 6
@bLoop:
  mov al, [si]
  cmp al, 32
  je @doneBLoop
  mov [di], al
  inc si
  inc di
  inc byte ptr [offset actentry.baud]
  loop @bLoop
@doneBLoop:

  mov al, 1
  mov di, offset actentry.name+1
  mov si, offset actstr + 24d
  mov cx, 256
@aLoop:
  db 66h; cmp word ptr [si],'o '; db 'n-'
  je @adone
  movsb
  inc byte ptr [offset actentry.name]
  dec cx
  jnz @aLoop
@adone:

@lineToShort:
end;

procedure calctime;
var eh, em, sh, sm, dh, dm : byte;
begin
  eh := actentry.ehour;
  em := actentry.emin;
  sh := actentry.shour;
  sm := actentry.smin;

  if eh < sh then eh := eh+24;

  dh := eh-sh;
  if sm<=em then dm := em-sm else
  begin
    dh:=dh-1;
    dm:=60+em-sm;
  end;

  if dm=0 then dm:=1;

  actentry.deltahour := dh;
  actentry.deltamin := dm;
end;



procedure scanfile;
var
  linenr    : word;
  badlogoff : byte;
  n         : byte;
  logon     : byte;
begin
  n := 1;
  begin
    linenr:=0;
    actentry.badlogoff := true;
    badlogoff:=0;
    repeat
      readline;
      if (actstr[0]<#5) or ((actstr[1]<>'>') and (actstr[1]<>'!')) then
      begin { ungltige Zeile }
        linenr:=0;
        actentry.name:='';
        actentry.baud      := '0';
        actentry.upload    := false;
        actentry.download  := false;
        actentry.badlogoff := true;
        actentry.msgwrite  := false;
        actentry.msgread   := false;
        badlogoff:=0;
        logon := 0;
      end
      else
      begin { gltige Zeile }
        inc(linenr);
        if linenr=1 then { letzte Zeile }
        begin
          getEdatetime;
          badlogoff:=checkforbadlogoff;
        end;
        if linenr=2 then { vorletzte Zeile }
        begin
          badlogoff:=badlogoff+checkforbadlogoff2;
        end;
        if msgwrite then actentry.msgwrite:=true;
        if msgread then actentry.msgread:=true;
        if checkForUpload then actentry.upload:=true;;
        if checkForDownload then actentry.Download:=true;;
        if (linenr<>1)and(linenr<>2) then
          if logon=0 then
          begin
            if checkForSecurity then logon := 1;
          end
           else
          begin
            if logon=1 then
            begin
              if checkForLogon then { erste Zeile }
              begin
                if actentry.baud='0' then actentry.baud:='LOCAL';
                getSDatetime;
                if badlogoff = 2 then actentry.badlogoff := false;
                calctime;
                userdata[n]:=actentry;
                n := n + 1;
                linenr:=0;
                actentry.name:='';
                actentry.baud      := '0';
                actentry.upload    := false;
                actentry.download  := false;
                actentry.badlogoff := true;
                actentry.msgwrite  := false;
                actentry.msgread   := false;
                badlogoff:=0;
                logon := 0;
              end;
            end;
          end;
      end;
    until (n > users) or ((filepos=0) and (bufpos=0));
    usersfound := n - 1;
  end;
end;
function writeColour(c, b : byte):string;
const colour : array [0..7] of string[2] = ('30','34','32','36','31','35','33','37');
      back   : array [0..7] of string[2] = ('40','44','42','46','41','45','43','47');
var trash : string;
begin
  trash:='[';

  if c > 7 then trash:=trash+'1;' else trash:=trash+'0;';
  if c > 7 then dec(c, 8);
  trash:=trash + colour[c] + ';';

  if b > 7 then dec(b, 8);
  trash:=trash + back[b] + 'm';
  writeColour:=trash;
end;

procedure saveansi;
const fileLBuf : pointer = ptr($B800,0);
var  ansifile : text;
     oldcol   : byte;
     buf2     : string;
     i        : word;
     y        : byte;
begin
    assign(ansifile,'C:\ICALL.ANS'); rewrite(ansifile);
    write(ansifile,#27+'[2J');

    oldCol := mem[$B800:1];
    buf2 := writeColour (oldCol and 15, oldcol shr 4);
    write( ansifile , buf2);
    i := 0;
    repeat;
      if mem[$B800:i+1] <> oldCol then
      begin
        oldCol := mem[$B800:i+1];
        buf2 := writeColour (oldCol and 15, oldCol shr 4);
        write(ansifile, buf2);
      end;
      write(ansifile,char(mem[$B800:i]));
      inc(i , 2);
    until i>23*160;
    write(ansifile,writecolour(7,0));
    close(ansifile);
end;

begin
  init;
  scanfile;

  asm
    mov ax, 3
    int 10h
    mov ax, 0b800h
    mov es, ax
    xor di, di
    mov si, offset mask
    mov cx, 2000
    rep movsw
  end;

  for bufpos := 1 to usersfound do
  begin
    TextColor(15); TextBackground( 0 );

    gotoxy( 4,bufpos+5);  write(userdata[usersfound-bufpos+1].name);

    gotoxy(25 , bufpos+5);
    if userdata[usersfound-bufpos+1].stag < 10 then write('0');
    write(userdata[usersfound-bufpos+1].stag,'.');

    gotoxy(28 , bufpos+5);
    if userdata[usersfound-bufpos+1].smonat < 10 then write('0');
    write(userdata[usersfound-bufpos+1].smonat);

    gotoxy(31 , bufpos+5);
    if userdata[usersfound-bufpos+1].shour < 10 then write('0');
    write(userdata[usersfound-bufpos+1].shour,':');

    gotoxy(34 , bufpos+5);
    if userdata[usersfound-bufpos+1].smin < 10 then write('0');
    write(userdata[usersfound-bufpos+1].smin);

    gotoxy(38 , bufpos+5);
    if userdata[usersfound-bufpos+1].etag < 10 then write('0');
    write(userdata[usersfound-bufpos+1].etag,'.');

    gotoxy(41 , bufpos+5);
    if userdata[usersfound-bufpos+1].emonat < 10 then write('0');
    write(userdata[usersfound-bufpos+1].emonat);

    gotoxy(44 , bufpos+5);
    if userdata[usersfound-bufpos+1].ehour < 10 then write('0');
    write(userdata[usersfound-bufpos+1].ehour,':');

    gotoxy(47 , bufpos+5);
    if userdata[usersfound-bufpos+1].emin < 10 then write('0');
    write(userdata[usersfound-bufpos+1].emin);

    gotoxy(51,bufpos+5);
    write(userdata[usersfound-bufpos+1].deltahour,'''');

    gotoxy(53,bufpos+5);
    if userdata[usersfound-bufpos+1].deltamin < 10 then write('0');
    write(userdata[usersfound-bufpos+1].deltamin,'''''');

    gotoxy(58,bufpos+5); write(userdata[usersfound-bufpos+1].baud);

    gotoxy(66,bufpos+5); if userdata[usersfound-bufpos+1].upload then write('u') else write('');
    gotoxy(68,bufpos+5); if userdata[usersfound-bufpos+1].download then write('d') else write('');

    gotoxy(72,bufpos+5); if userdata[usersfound-bufpos+1].msgread then write('r') else write('');
    gotoxy(74,bufpos+5); if userdata[usersfound-bufpos+1].msgwrite then write('w') else write('');

    gotoxy(70,bufpos+5); if userdata[usersfound-bufpos+1].badlogoff then write('b') else write('');
  end;

  saveansi;

  done;
end.